(function (ctx,factory) {
    var nameSpace = 'feild_4578843378267869145';
    if(!window[nameSpace]){
        var Builder = factory(ctx,nameSpace);
        window[nameSpace] = {
            instance: {}
        };
        window[nameSpace].init = function (options) {
            window[nameSpace].instance[options.privateId] = new Builder(options);
    };
    }
})(typeof $ === 'undefined' ? top.$ : $,function($,domain){

    function App(options) {
        var self = this;
        self.appendChildDom = function (adaptation, messageObj, privateId, getData) {
            self.customButton(adaptation, messageObj, privateId, getData);
        };
        self.customButton = function (adaptation, messageObj, privateId, getData) {

            if (adaptation) {
                self.adaptation = adaptation;
            }
            //----------创建DOM---------
            var domStructure = '';
            var box = document.querySelector('#' + privateId);
            if(!box) {
                console.warn('未找到控件dom');
                return;
            }
            if (getData.auth === 'browse') {
                domStructure = '<section class="cap4-images is-one "><div><div class="cap4-images__cnt" style="border:none;"><div class="cap4-images__items"><div class="cap4-images__holder"></div></div></div></div></section>';
            }else if (getData.auth === 'hide') {
                box.style.display="none";
                return;
            }else {
                domStructure = '<section class="cap4-images is-one "><div><div class="cap4-images__cnt"><div class="cap4-images__items"><div class="cap4-images__holder"></div></div><div class="cap4-images__picker upload ' + privateId + '"><div class="icon CAP cap-icon-e-invoice"></div></div></div></div></section>';
            };
            box.innerHTML = domStructure;
            if (self.getData.attachmentInfo.attachmentInfos && self.getData.attachmentInfo.attachmentInfos.length > 0) {
                var filename=encodeURIComponent(self.getData.attachmentInfo.attachmentInfos[0].filename);
                if (getData.auth === 'browse') {
                    box.querySelector(".cap4-images__items").innerHTML = '<div style="cap4-images__it"><a style="display: block;max-height: 20px;" target="myFormIframe" href="/seeyon/fileDownload.do?method=download&fileId=' + self.getData.attachmentInfo.attachmentInfos[0].fileUrl + '&v=' + self.getData.attachmentInfo.attachmentInfos[0].v + '&createDate=' + self.getData.attachmentInfo.attachmentInfos[0].createdate + '&filename=' +filename + '"title="' + filename + '">'+self.getData.attachmentInfo.attachmentInfos[0].filename + '</a></div>';
                } else {
                    box.querySelector(".cap4-images__items").innerHTML = '<div style="cap4-images__it"><a style="display: block;max-height: 20px;" target="myFormIframe" href="/seeyon/fileDownload.do?method=download&fileId=' + self.getData.attachmentInfo.attachmentInfos[0].fileUrl + '&v=' + self.getData.attachmentInfo.attachmentInfos[0].v + '&createDate=' + self.getData.attachmentInfo.attachmentInfos[0].createdate + '&filename=' +filename + '"title="' + filename + '">' +self.getData.attachmentInfo.attachmentInfos[0].filename + '</a><div class="cap4-images__close"><i class="icon CAP cap-icon-guanbi delete"></i></div></div>';
                }
                box.querySelector('.upload') && (box.querySelector('.upload').style.display = "none");
                if (box.querySelector('.delete')) {
                    box.querySelector('.delete').addEventListener('click', function () {
                        var field = box.querySelector(".cap4-images__items");
                        field.removeChild(field.childNodes[0]);
                        box.querySelector('.upload') && (box.querySelector('.upload').style.display = "");
                        self.aId = self.getData.attachmentInfo.attachmentInfos[0].id;
                        if (self.adaptation.backfillFormAttachment) {
                            var attachmentData = [
                                {
                                    tableName: self.formMessage.tableName,
                                    tableCategory: self.formMessage.tableCategory,
                                    updateRecordId: self.getData.recordId || '',
                                    handlerMode: 'delete',
                                    fieldName: self.getData.id,
                                    deleteAttchmentData: [self.aId]
                                }
                            ];
                            self.adaptation.backfillFormAttachment(JSON.parse(JSON.stringify(attachmentData)), privateId);
                }
                    });
                }
            }else{
                if (getData.auth === 'edit'){
                    box.querySelector(".cap4-images__cnt").style.background=(messageObj.isNotNull=='1'?'#fef0d0':'');
                }
            }
            if (document.querySelector('.' + privateId)) {
                document.querySelector('.' + privateId).addEventListener('click', function () {
                    if(self.messageObj.customFieldInfo.customParam==null){
                        top.$.alert("请联系应用设计师，在表单编辑器中设置电子发票控件的属性映射！");
                        return;
                    }
                    var opts = {
                        type: 0,
                        applicationCategory: 66,
                        maxSize: '',
                        isEncrypt: '',
                        popupTitleKey: '',
                        attachmentTrId: 'Att',
                        takeOver: 'false',
                        firstSave: 'true',
                        quantity: 1,
                        extensions: 'pdf'
                    };
                    //文件上传成功后
                    self.uploadFile(opts, function (fileurls, atts) {
                        if (atts && atts.length > 0) {
                            var att = atts;
                            att[0].refefence = self.getData.attachmentInfo.baseAttachmentInfo.reference;
                            att[0].subReference = self.getData.attachmentInfo.baseAttachmentInfo.subReference;
                            self.att = att;
                            box.querySelector(".cap4-images__items").innerHTML = '<div style="cap4-images__it"><a title="'+atts[0].filename+'" style="display: block;max-height: 20px;" target="myFormIframe" href="/seeyon/fileDownload.do?method=download&fileId='+self.att[0].fileUrl+'&v='+self.att[0].v+'&createDate='+self.att[0].createDate+'&filename='+encodeURIComponent(self.att[0].filename)+'">'+atts[0].filename+'</a><div class="cap4-images__close"><i class="icon CAP cap-icon-guanbi delete"></i></div></div>';
                            //icon botton
                            box.querySelector(".cap4-images__cnt").style.background='';
                            box.querySelector('.upload').style.display = "none";
                            self.aId = atts[0].id;
                            box.querySelector('.delete').addEventListener('click', function () {
                                var field = box.querySelector(".cap4-images__items");
                                field.removeChild(field.childNodes[0]);
                                box.querySelector('.upload').style.display = "";
                                box.querySelector(".cap4-images__cnt").style.background=(messageObj.isNotNull=='1'?'#fef0d0':'');
                                if (self.adaptation.backfillFormAttachment) {
                                    var attachmentData = [
                                        {
                                            tableName: self.formMessage.tableName,
                                            tableCategory: self.formMessage.tableCategory,
                                            updateRecordId: self.getData.recordId || '',
                                            handlerMode: 'delete',
                                            fieldName: self.getData.id,
                                            deleteAttchmentData: [self.aId]
                                        }
                                    ];
                                    //backfillFormAttachment（向数据库删除需要删除的内容）
                                    self.adaptation.backfillFormAttachment(JSON.parse(JSON.stringify(attachmentData)),privateId);
                                }
                            });
                            //rest
                            var content = self.messageObj.formdata.content;
                            var params = {
                                formId: content.contentTemplateId,
                                rightId: content.rightId,
                                fieldName: getData.id,
                                fileId: atts[0].fileUrl,
                                masterId: content.contentDataId,
                                subId: getData.recordId || '0'
                            };
                            var process = top.$.progressBar({
                                text: "解析中"
                            });
                            $.ajax({
                                type: 'get',
                                url: (_ctxPath ? _ctxPath : '/seeyon') + "/rest/cap4/formEinvoice/parseEinvoiceFileAndFillBack?" + self.parseParam(params),
                                dataType: 'json',
                                contentType: 'application/json',
                                beforeSend: function () {

                                },
                                success: function (res) {
                                    process.close();
                                    if (res.success || res.code == "0") {
                                        if (self.adaptation.backfillFormControlData) {
                                            var backfillData = [];
                                            var backfillItem = {
                                                tableName: self.formMessage.tableName,
                                                tableCategory: self.formMessage.tableCategory,
                                                updateData: {},
                                                updateRecordId: ''
                                            }
                                            if (self.countProperties(res.data) === 0) {
                                                return;
                                            } else {
                                                var key = [];
                                                for (var k in res.data) {
                                                    if (k.split('_').length > 1) {
                                                        key.push(k.split('_')[1]);
                                                    }
                                                }

                                                if (key.length == 0) {
                                                    backfillItem.updateData = res.data;
                                                    backfillData.push(backfillItem);
                                                } else {
                                                    if (self.removal(key).length === 1) {
                                                        if (self.countProperties(res.data) === key.length) {
                                                            backfillItem.updateData = res.data;
                                                            backfillItem.updateRecordId = key[0];
                                                            backfillData.push(backfillItem);
                                                        } else {
                                                            var mTable = {};
                                                            var sTable = {};
                                                            for (p in res.data) {
                                                                if (p.split('_').length === 2 && p.split('_')[1] === key[0]) {
                                                                    sTable[p] = res.data[p];
                                                                } else {
                                                                    mTable[p] = res.data[p];
                                                                }
                                                            }
                                                            backfillData.push({
                                                                updateData: mTable,
                                                                tableName: self.formMessage.tableName,
                                                                tableCategory: self.formMessage.tableCategory,
                                                            });
                                                            backfillData.push({
                                                                updateData: sTable,
                                                                tableName: self.formMessage.tableName,
                                                                tableCategory: self.formMessage.tableCategory,
                                                                updateRecordId: key[0]
                                                            });
                                                        }
                                                    } else {
                                                        var len = removal(key);

                                                        for (var i = 0; i <= len.length; i++) {
                                                            var tableData = {};
                                                            for (p in res.data) {
                                                                if (p.split('_').length === 2) {
                                                                    if (p.split('_')[1] === len[i]) {
                                                                        tableData[p] = res.data[p];
                                                                    }
                                                                } else {
                                                                    if (i === len.length) {
                                                                        tableData[p] = res.data[p];
                                                                    }
                                                                }
                                                            }
                                                            backfillData.push({
                                                                updateData: tableData,
                                                                tableName: self.formMessage.tableName,
                                                                tableCategory: self.formMessage.tableCategory,
                                                                updateRecordId: len[i] || ''
                                                            });
                                                        }
                                                    }
                                                }
                                            }
                                            if (backfillData && backfillData.length > 0) {
                                                for (var i = 0; i < backfillData.length; i++) {
                                                    for (var k in backfillData[i].updateData) {
                                                        if (k.split('_').length > 1) {
                                                            backfillData[i].updateData[k.split('_')[0]] = backfillData[i].updateData[k];
                                                            delete backfillData[i].updateData[k];
                                                        } else {
                                                            backfillData[i].updateData[k] = backfillData[i].updateData[k];
                                                        }
                                                    }
                                                }
                                            }
                                            //backfillFormControlData（回填电子发票相关联的其它控件的值）
                                            self.adaptation.backfillFormControlData(backfillData, privateId);
                                        }
                                        if (self.adaptation.backfillFormAttachment) {
                                            var attachmentData = [
                                                {
                                                    tableName: self.formMessage.tableName,
                                                    tableCategory: self.formMessage.tableCategory,
                                                    updateRecordId: self.getData.recordId || '',
                                                    handlerMode: 'add',
                                                    fieldName: self.getData.id,
                                                    addAttchmentData: self.att
                                                }
                                            ]
                                            //backfillFormAttachment（向数据库添加新建的内容）
                                            self.adaptation.backfillFormAttachment(JSON.parse(JSON.stringify(attachmentData)), privateId);
                                        }
                                    } else {
                                    }
                                },
                                complete: function () {
                                    process.close();
                                },
                                error:function (errorMsg) {
                                    var retObj = $.parseJSON(errorMsg.responseText);
                                    top.$.alert(retObj.message);
                                    process.close();
                                }
                            });
                        }

                    });
                });
            }
        }
        self.download = function () {

        }
        self.removal = function (arr) {
            var res = [];
            var json = {};
            for (var i = 0; i < arr.length; i++) {
                if (!json[arr[i]]) {
                    res.push(arr[i]);
                    json[arr[i]] = 1;
                }
            }
            return res;
        }

        self.countProperties = function (obj) {
            var count = 0;
            for (var property in obj) {
                if (Object.prototype.hasOwnProperty.call(obj, property)) {
                    count++;
                }
            }
            return count;
        }
        //定义上传文件接口
        self.uploadFile = function (options, callback) {
            self.parseParam = function (param, key) {
                var paramStr = "";
                if (param instanceof String || param instanceof Number || param instanceof Boolean) {
                    paramStr += "&" + key + "=" + encodeURIComponent(param);
                } else {
                    $.each(param, function (i) {
                        var k = key == null ? i : key + (param instanceof Array ? "[" + i + "]" : "." + i);
                        paramStr += '&' + self.parseParam(this, k);
                    });
                }
                return paramStr.substr(1);
            }

            options.CSRFTOKEN = top.CsrfGuard.getToken();
            var url = (_ctxPath ? _ctxPath : '/seeyon') + '/fileUpload.do?callMethod=_dinvoiceUploadFileCallback&' + self.parseParam(options);
            getCtpTop().addattachDialog = null;
            getCtpTop().addattachDialog = getCtpTop().$.dialog({
                title: $.i18n('fileupload.page.title'),
                transParams: {
                    parentWin: window
                },
                url: url,
                width: 400,
                height: 250
            });

            window._dinvoiceUploadFileCallback = function (att, repeat) {
                var atts = null;
                atts = att;

                if (atts && atts.instance.length) {
                    //处理一下返回的数据，拼接一下url，统一修改
                    atts.instance.forEach(function (item) {
                        var opts = {
                            createDate: item.createDate.split(' ')[0],
                            fileId: item.fileUrl
                        };
                        var url = (_ctxPath ? _ctxPath : '/seeyon') + '/fileUpload.do?method=showRTE&type=image&showType=big&' + self.parseParam(opts);
                        item.src = url; //增加src属性，写入url
                    });
                    callback(null, atts.instance);
                } else {
                    callback(null, []);
                }
            }
        }
        self.initParams(options);
    }

    App.prototype.initParams = function (res) {
        var self = this;
        var adaptation = res.adaptation;
        var url_prefix = res.url_prefix;
        var privateId = res.privateId;
        self.formMessage = res.formMessage;
        self.getData = res.getData;
        var dataObj = adaptation.childrenGetPrivateMessage(privateId);
        self.messageObj = adaptation.childrenGetData(privateId);
        self.appendChildDom(adaptation, self.messageObj, privateId, res.getData);

        // 监听是否数据刷新
        adaptation.ObserverEvent.listen('Event' + privateId, function () {
            //self.messageObj = adaptation.childrenGetData(privateId);
            //self.appendChildDom(adaptation, self.messageObj, privateId);
        });
    };
    return App;
});
